
; Percent.SC.  Written by Angus Burns.  20-Feb-1995

; Browsing through the Compuserve libs, could not find a percentage completed
; indicator that I liked so I wrote my own.

; I like my code to be self contained and complete so this procedure will
; Setup the window, update the completed bar and remove the window on 100%.

; A stub is included at the end to demonstrate it, you should remove it before
; adding it to your utils.lib.

; I hope it is of use to you and I also hope you find a more elegant way to
; achieve the same result and that you will e-mail me your solution.  TIA!

; I basically got sick of tweaking it and am releasing it in the hope someone
; may spot something missing...<s>

; Angus Burns.  Sydney, Australia.  100236,231.


PROC UPDATE_SCALE(counter,count)            ; update scale
PRIVATE percentdone,units

	; Setup everything the first time through...AB  18.2.95
	IF NOT ISASSIGNED(aba_percent.y) THEN
		DYNARRAY aba_percent.y[]
		aba_percent.y["OLD%"]= 0
		Dynarray WinAtt[]
		WinAtt["HASFRAME"]	= False
		WinAtt["CANVAS"]	= True
		WinAtt["STYLE"]		= 30
		WINDOW CREATE FLOATING @9,24 HEIGHT 4 WIDTH 31
			ATTRIBUTES WinAtt TO aba_percent.w
		WINDOW SELECT aba_percent.w
		PAINTCANVAS FILL " " ATTRIBUTE 0 1,3,1,27; Black line.
		PAINTCANVAS BORDER FILL CHR(196) ATTRIBUTE 16 0,2,0,28; Top Row
		PAINTCANVAS BORDER FILL CHR(218) ATTRIBUTE 16 0,1,0,1; TL Cnr
		PAINTCANVAS BORDER FILL CHR(179) ATTRIBUTE 16 1,1,2,1; L Side
		PAINTCANVAS BORDER FILL CHR(192) ATTRIBUTE 16 3,1,3,1; BL Cnr
		PAINTCANVAS BORDER FILL CHR(196) ATTRIBUTE 25 3,2,3,28; Bot Row
		PAINTCANVAS BORDER FILL CHR(191) ATTRIBUTE 25 0,29,0,29; TR Cnr
		PAINTCANVAS BORDER FILL CHR(179) ATTRIBUTE 25 1,29,2,29; R Side
		PAINTCANVAS BORDER FILL CHR(217) ATTRIBUTE 25 3,29,3,29; BR Cnr
		@2,3	??"0%  25%   50%   75%  100%"
		PAINTCANVAS ATTRIBUTE 27 2,3,2,27; Text in White...AB
		CURSOR OFF
	ENDIF

; Main block of code, controls the bar progress...AB 18.2.95
	percentdone = INT(counter*100/count)
	IF percentdone > aba_percent.y["OLD%"] THEN
		IF WINDOW()<> aba_percent.w THEN WINDOW SELECT aba_percent.w ENDIF
		@1,3+INT(aba_percent.y["OLD%"]/4)
		units=MOD(percentdone,4)
		?? CHR(IIF(units=0,219,175+units))
		IF percentdone>4 THEN
			@1,3 ?? FILL(CHR(219),INT(percentdone/4)-1) ENDIF
		aba_percent.y["OLD%"] = percentdone
		;MESSAGE percentdone; for debugging
	ENDIF

; Last time through to clean things up...AB 18.2.95
	IF counter=count THEN
		IF count<>0 AND counter<>0 THEN
			SLEEP(250); Leave on screen for 1/4 second...AB
		ENDIF; Sending 0,0 will remove the window with no delay.
		RELEASE VARS aba_percent.y
		WINDOW SELECT aba_percent.w
		WINDOW CLOSE
		SETCANVAS DEFAULT
		CURSOR NORMAL
	ENDIF; Last time through
ENDPROC


; Stub of code to test standalone.  Comment out the lines below when using...AB
;z=TICKS(); To test overhead.
FOR x FROM 1 TO 100; STEP 4
	update_scale(x,100)
	;y=getchar()	; Either stop every step OR
	SLEEP(125)	; slow down the loop to watch it...AB
ENDFOR
;y=TICKS()
;QUIT STRVAL(y-z)
